Added tag 0.6.28 for changeset 4b46b152011b
[grml-autoconfig.git] / autoconfig.functions
1 #!/bin/zsh
2 # Filename:      autoconfig.functions
3 # Purpose:       basic system configuration and hardware setup for grml system
4 # Authors:       grml-team (grml.org), (c) Klaus Knopper <knopper@knopper.net>, (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 # Latest change: Son Mär 25 12:32:37 CEST 2007 [mika]
8 ################################################################################
9
10 # {{{ path, variables, signals, umask, zsh
11 export PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin"
12 DEBUG="/dev/null"
13 KERNEL="$(uname -r)"
14 umask 022
15
16 # Ignore these signals in non-interactive mode: INT, TERM, SEGV
17 [ -z "$PS1" ] && trap "" 2 3 11
18
19 # zsh stuff
20 iszsh(){
21 if [ -n "$ZSH_VERSION" ] ; then
22   return 0
23 else
24   return 1
25 fi
26 }
27 # avoid 'no matches found: ...'
28 iszsh && setopt no_nomatch # || echo "Warning: not running under zsh!"
29 # }}}
30
31 ### {{{ Utility Functions
32
33 # Simple shell grep
34 stringinfile(){
35   case "$(cat $2)" in *$1*) return 0;; esac
36   return 1
37 }
38
39 # same for strings
40 stringinstring(){
41   case "$2" in *$1*) return 0;; esac
42   return 1
43 }
44
45 # Reread boot command line; echo last parameter's argument or return false.
46 getbootparam(){
47   stringinstring " $1=" "$CMDLINE" || return 1
48   result="${CMDLINE##*$1=}"
49   result="${result%%[   ]*}"
50   echo "$result"
51   return 0
52 }
53
54 # Check boot commandline for specified option
55 checkbootparam(){
56   stringinstring " $1" "$CMDLINE"
57   return "$?"
58 }
59
60 checkvalue(){
61   if [ "$1" = "yes" ] ; then
62     return 0
63   else
64     return 1
65   fi
66 }
67
68 checkgrmlsmall(){
69   grep -q small /etc/grml_version 2>>$DEBUG && return 0 || return 1
70 }
71
72 checkgrmlusb(){
73   grep -q usb /etc/grml_version 2>>$DEBUG && return 0 || return 1
74 }
75 ### }}}
76
77 # {{{ filesystems (proc, pts, sys) and fixes
78 mount_proc(){
79   [ -f /proc/version ] || mount -t proc /proc /proc 2>/dev/null
80 }
81
82 mount_pts(){
83   stringinfile "/dev/pts" /proc/mounts || mount -t devpts /dev/pts /dev/pts 2>/dev/null
84 }
85
86 mount_sys(){
87   [ -d /sys/devices ] || mount -t sysfs /sys /sys 2>/dev/null
88 }
89 # }}}
90
91 # {{{ Read in boot parameters
92 [ -f /proc/version ] || mount_proc # make sure we can access /proc/cmdline when sourcing this file too
93 CMDLINE="$(cat /proc/cmdline)"
94 [ -d /cdrom/bootparams/ ] && CMDLINE="$CMDLINE $(cat /cdrom/bootparams/* | tr '\n' ' ')"
95 # }}}
96
97 # {{{ Check if we are running from the grml-CD or HD
98 INSTALLED=""
99 [ -e /GRML/etc/grml_cd ] || INSTALLED="yes"
100
101 # testcd
102 TESTCD=""
103 checkbootparam "testcd" >>$DEBUG 2>&1 && TESTCD="yes"
104 # }}}
105
106 # {{{ source lsb-functions , color handling
107 if checkbootparam "nocolor"; then
108   RC_NOCOLOR=yes
109   . /etc/grml/lsb-functions
110   einfo "Disabling colors in bootsequence as requested on commandline." ; eend 0
111 else
112   . /etc/grml/lsb-functions
113   . /etc/grml_colors
114 fi
115 # }}}
116
117 # {{{ debug
118 config_debug(){
119  if checkbootparam "debug"; then
120    BOOTDEBUG="yes"
121  fi
122  if stringinstring "BOOT_IMAGE=debug " "$CMDLINE" ; then
123    BOOTDEBUG="yes"
124  fi
125  rundebugshell(){
126   if [ -n "$BOOTDEBUG" ]; then
127     einfo "Starting intermediate shell stage $stage as requested by \"debug\" option."
128     eindent
129     if [ -r /etc/grml/screenrc ] ; then
130        einfo "Starting GNU screen to be able to use a full featured shell environment."
131        einfo "Just exit the shells (and therefore screen) to continue boot process..."
132        /bin/zsh -c "screen -c /etc/grml/screenrc"
133     else
134       einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
135       einfo "Just exit the shell to continue boot process..."
136       /bin/zsh
137     fi
138     eoutdent
139   fi
140  }
141 }
142 # }}}
143
144 # {{{ log
145 config_log(){
146 if checkbootparam "log"; then
147   export DEBUG="/tmp/grml.log.`date +%Y%m%d`"
148   touch $DEBUG
149   einfo "Bootparameter log found. Log files: ${DEBUG} and /var/log/boot."
150   eindent
151     einfo "Starting bootlogd."
152     bootlogd -r -c 1>>$DEBUG 2>&1 ; eend $?
153   eoutdent
154 else
155   DEBUG="/dev/null"
156 fi
157 }
158 # }}}
159
160 # {{{ Check if we are in interactive startup mode
161 INTERACTIVE=""
162 stringinstring "BOOT_IMAGE=expert " "$CMDLINE" && INTERACTIVE="yes"
163 # }}}
164
165 # {{{ set firmware timeout via bootparam
166 config_fwtimeout(){
167  if checkbootparam fwtimeout ; then
168    TIMEOUT="$(getbootparam 'fwtimeout' 2>>$DEBUG)"
169    einfo "Bootoption fwtimeout found. (Re)Loading firmware_class module."
170    rmmod firmware_class 1>>$DEBUG 2>&1
171    modprobe firmware_class ; eend $?
172  fi
173  if [ -z "$TIMEOUT" ] ; then
174    TIMEOUT="100" # linux kernel default: 10
175  fi
176  if [ -f /sys/class/firmware/timeout ] ; then
177    einfo "Setting timeout for firmware loading to ${TIMEOUT}."
178    echo 100 > /sys/class/firmware/timeout ; eend $?
179  fi
180 }
181 # }}}
182
183 ### {{{ language configuration / localization
184 config_language(){
185
186  einfo "Activating language settings:"
187  eindent
188
189  # people can specify $LANGUAGE and $CONSOLEFONT in a config file:
190  [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
191
192  grep -q ' lang=.*-utf8' /proc/cmdline && UTF8='yes' || UTF8=''
193
194  # check for bootoption which overrides config from /etc/grml/autoconfig:
195  BOOT_LANGUAGE="$(getbootparam lang 2>>$DEBUG)"
196  [ -n "$BOOT_LANGUAGE" ] && LANGUAGE="$BOOT_LANGUAGE"
197
198  # set default to 'en' in live-cd mode if $LANGUAGE is not yet set:
199  if [ -z "$INSTALLED" ] ; then
200     [ -n "$LANGUAGE" ] || LANGUAGE='en-utf8'
201  fi
202
203  # if bootoption lang is used update /etc/default/locale, otherwise *not*!
204  if [ -n "$BOOT_LANGUAGE" ] ; then
205     [ -x /usr/sbin/grml-setlang ] && /usr/sbin/grml-setlang "$LANGUAGE"
206  fi
207
208  # set console font
209  if [ -z "$CONSOLEFONT" ] ; then
210     if ! checkbootparam "nodefaultfont" >>$DEBUG 2>&1 ; then
211        # [ -n "$UTF8" ] && CONSOLEFONT='LatArCyrHeb-16' || CONSOLEFONT='Lat15-Terminus16'
212        # if [ -r /usr/share/consolefonts/Lat15-Terminus16.psf.gz ] ; then
213        if [ -r /usr/share/consolefonts/Uni3-Terminus16.psf.gz ] ; then
214           CONSOLEFONT='Uni3-Terminus16'
215        else
216           ewarn "/usr/share/consolefonts/Uni3-Terminus16.psf.gz not available. Please upgrade package console-terminus." ; eend 1
217        fi
218     fi
219  fi
220
221  # export it now, so error messages get translated, too
222  if checkgrmlsmall ; then
223     export LANG='C' # grml-small does not provide any further locales
224  else
225     [ -r /etc/default/locale ] && . /etc/default/locale
226     export LANG LANGUAGE
227  fi
228
229  # configure keyboard layout, read in already set values first:
230  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
231
232  # now allow keyboard override by boot commandline for later use:
233  KKEYBOARD="$(getbootparam keyboard 2>>$DEBUG)"
234  [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
235  # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
236  [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
237  [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
238
239  # modify /etc/sysconfig/keyboard only in live-cd mode:
240  if [ -z "$INSTALLED" ] ; then
241
242    local LANGUAGE="$BOOT_LANGUAGE"
243    . /etc/grml/language-functions
244    # allow setting xkeyboard explicitly different than console keyboard
245    KXKEYBOARD="$(getbootparam xkeyboard 2>>$DEBUG)"
246    if [ -n "$KXKEYBOARD" ]; then
247       XKEYBOARD="$KXKEYBOARD"
248       KDEKEYBOARD="$KXKEYBOARD"
249    elif [ -n "$KKEYBOARD" ]; then
250       XKEYBOARD="$KKEYBOARD"
251       KDEKEYBOARD="$KKEYBOARD"
252    fi
253
254    # duplicate of previous code to make sure /etc/grml/language-functions
255    # does not overwrite our values....
256    # now allow keyboard override by boot commandline for later use:
257    KKEYBOARD="$(getbootparam keyboard 2>>$DEBUG)"
258    [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
259    # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
260    [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
261    [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
262
263    # write keyboard related variables to file for later use
264    [ -d /etc/sysconfig ] || mkdir /etc/sysconfig
265    echo "KEYTABLE=\"$KEYTABLE\""          > /etc/sysconfig/keyboard
266    echo "XKEYBOARD=\"$XKEYBOARD\""       >> /etc/sysconfig/keyboard
267    echo "KDEKEYBOARD=\"$KDEKEYBOARD\""   >> /etc/sysconfig/keyboard
268    echo "KDEKEYBOARDS=\"$KDEKEYBOARDS\"" >> /etc/sysconfig/keyboard
269  fi
270
271  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
272
273   # Set default keyboard before interactive setup
274   if [ -n "$KEYTABLE" ] ; then
275    einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
276    loadkeys -q $KEYTABLE &
277    eend $?
278   fi
279
280   if [ -n "$CONSOLEFONT" ] ; then
281      einfo "Running consolechars using ${CONSOLEFONT}"
282      consolechars -f $CONSOLEFONT || consolechars -d
283      eend $?
284   fi
285
286   # we have to set up all consoles, therefore loop it over all ttys:
287   if [ -n "$CHARMAP" ] ; then
288      einfo "Running consolechars for ${CHARMAP}"
289      NUM_CONSOLES=`fgconsole --next-available`
290      NUM_CONSOLES=`expr ${NUM_CONSOLES} - 1`
291      [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
292      for vc in `seq 0 ${NUM_CONSOLES}`  ; do
293        consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
294      done
295      eend ${RC}
296   fi
297
298   # activate unicode console if running within utf8 environment
299   if [ -r /etc/default/locale ] ; then
300      if grep -q "LANG=.*UTF" /etc/default/locale ; then
301         einfo "Setting up unicode environment."
302         unicode_start
303         eend $?
304      fi
305   fi
306
307  eoutdent
308 }
309 # }}}
310
311 # {{{ Set hostname
312 config_hostname(){
313  if checkbootparam hostname ; then
314   HOSTNAME="$(getbootparam 'hostname' 2>>$DEBUG)"
315   einfo "Setting hostname to $HOSTNAME as requested."
316   sed -i "s/^127.0.0.1.*localhost/127.0.0.1 $HOSTNAME localhost/" /etc/hosts
317   hostname $HOSTNAME ; eend $?
318  else
319   hostname --file /etc/hostname
320  fi
321 }
322 # }}}
323
324 # fstabuser (needed when running from harddisk with username != grml {{{
325 config_userfstab(){
326   [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
327   if [ -n "$CONFIG_FSTAB_USER" ] ; then
328      fstabuser="$CONFIG_FSTAB_USER"
329   else
330      fstabuser=$(getent passwd 1000 | cut -d: -f1)
331   fi
332   # if not yet set fall back to default 'grml' user
333   [ -n "$fstabuser" ] || fstabuser='grml'
334 }
335 # }}}
336
337 # {{{ Set clock (Local time is more often used than GMT, so it is default)
338 config_time(){
339  # don't touch the files if running from harddisk:
340  if [ -z "$INSTALLED" ]; then
341     UTC=""
342     checkbootparam utc >>$DEBUG 2>&1 && UTC="-u"
343     checkbootparam gmt >>$DEBUG 2>&1 && UTC="-u"
344     # hwclock uses the TZ variable
345     [ -r /etc/timezone ] && TZ=$(cat /etc/timezone)
346     [ -n "$TZ" ] || TZ=Europe/Vienna
347
348     if ! [ -r /dev/rtc ] ; then
349       ewarn "Realtime clock not available, skipping execution of hwclock therefore." ; eend 0
350     else
351       ERROR=$(TZ="$TZ" hwclock $UTC -s 2>&1 | head -1) ; RC=$?
352       if [ -n "$ERROR" ] ; then
353          eindent
354          ERROR=$(TZ="$TZ" hwclock $UTC -s --directisa 2>&1 | head -1)
355          if [ -n "$ERROR" ] ; then
356             eerror "Problem running hwclock: $ERROR" ; eend 1
357          fi
358          eoutdent
359       fi
360     fi
361  fi
362 }
363 # }}}
364
365 # {{{ print kernel info
366 config_kernel(){
367   vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMware/Qemu${NORMAL}"
368   [ -d /proc/xen ] && VMWARE='' # vmware-detect returns '0' when running with a Xen-enabled kernel
369   einfo "Running Linux Kernel $KERNEL $VMWARE" ; eend 0
370   if [ -r /proc/cpuinfo ] ; then
371      if egrep -q '^flags.*(vmx|svm)' /proc/cpuinfo ; then
372        eindent
373        einfo 'CPU(s) featuring virtualization technology detected' ; eend 0
374        eoutdent
375      fi
376   fi
377   if [ -d /proc/xen ] ; then
378      eindent
379      einfo 'Running kernel featuring support for Xen detected' ; eend 0
380      eoutdent
381   fi
382 }
383 # }}}
384
385 # {{{ vmware specific stuff
386 config_vmware(){
387 if checkbootparam novmware ; then
388    ewarn "Skipping running vmware specific stuff as requested on boot commandline." ; eend 0
389 else
390    if [ -z "$INSTALLED" ] ; then
391       if ! checkbootparam qemu ; then
392          if vmware-detect ; then
393             if [ -r /etc/X11/xorg.conf.vmware ] ; then
394                einfo "VMware: Copying /etc/X11/xorg.conf.vmware to /etc/X11/xorg.conf"
395                cp /etc/X11/xorg.conf.vmware /etc/X11/xorg.conf ; eend $?
396             fi
397          fi
398       fi
399    fi
400 fi
401 }
402 # }}}
403
404 # {{{ qemu specific stuff
405 config_qemu(){
406 if checkbootparam qemu ; then
407    if [ -r /etc/X11/xorg.conf.example ] ; then
408       einfo "Qemu: Copying /etc/X11/xorg.conf.example to /etc/X11/xorg.conf"
409       cp /etc/X11/xorg.conf.example /etc/X11/xorg.conf ; eend $?
410    fi
411 fi
412 }
413 # }}}
414
415 # {{{ ld.so.cache + depmod
416 config_ld_mod(){
417 if [ -n "$INSTALLED" ]; then
418  if ! [ -r /etc/grml.first.boot ] ; then
419   einfo "Running from HD for the first time, regenerate ld.so.cache and modules.dep:"
420   eindent
421 # Regenerate ld.so.cache and module dependencies on HD
422     einfo "Running ldconfig" ; ldconfig  ; eend $?
423     einfo "Running depmod"   ; depmod -a ; eend $?
424     touch /etc/grml.first.boot
425     eend 0
426   eoutdent
427  fi
428 fi
429 }
430 # }}}
431
432 # update_progress {{{
433 update_progress(){
434   # be sure we are non-blocking
435   (echo "$1" > /etc/sysconfig/progress) &
436 }
437 # }}}
438
439 # {{{ timezone
440 config_timezone(){
441  # don't touch the files if running from harddisk:
442  if [ -z "$INSTALLED" ]; then
443   einfo "Setting timezone."
444   KTZ="$(getbootparam tz 2>>$DEBUG)"
445   [ -f "/usr/share/zoneinfo/$KTZ" ] && TZ="$KTZ"
446   rm -f /etc/localtime
447   cp "/usr/share/zoneinfo/$TZ" /etc/localtime && eend 0
448  fi
449 }
450 # }}}
451
452 # small computer / nearly no ram {{{
453 config_small(){
454
455 RAM=$(/usr/bin/gawk '/MemTotal/{print $2}' /proc/meminfo)
456 # MEM=$(/usr/bin/gawk 'BEGIN{m=0};/MemFree|Cached|SwapFree/{m+=$2};END{print m}' /proc/meminfo)
457 eindent
458
459 if checkbootparam "small"; then
460   einfo "Information: ${RAM} kB of RAM available." ; eend 0
461   einfo "Bootoption small detected. Activating small system."
462   if [ -r /etc/inittab.small ] ; then
463     mv /etc/inittab /etc/inittab.normal
464     mv /etc/inittab.small /etc/inittab
465   else
466     sed -i 's/^9/#&/' /etc/inittab
467     sed -i 's/^10/#&/' /etc/inittab
468     sed -i 's/^11/#&/' /etc/inittab
469     sed -i 's/^12/#&/' /etc/inittab
470   fi
471   /sbin/telinit q ; eend $?
472 else
473   if checkgrmlsmall ; then
474     if [[ $RAM -lt 25000 ]] ; then
475       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
476       ewarn "At least 32MB of RAM should be available for grml-small." ; eend 1
477       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
478       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
479       /bin/zsh --login
480     else
481       einfo "Information: ${RAM} kB of RAM available." ; eend 0
482     fi
483   else
484     if [[ $RAM -lt 58000 ]] ; then
485       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
486       ewarn "At least 64MB of RAM should be available for grml." ; eend 1
487       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
488       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
489       /bin/zsh --login
490     else
491       einfo "Information: ${RAM} kB of RAM available." ; eend 0
492     fi
493   fi
494 fi
495 eoutdent
496 }
497 # }}}
498
499 # skip startup of w3m {{{
500 config_fast(){
501 if checkbootparam "fast"; then
502   ewarn "Bootoption fast detected. Skipping startup of w3m."
503     sed -i 's#^1:.*#1:12345:respawn:/usr/bin/openvt -f -c 1 -w -- /bin/zsh#' /etc/inittab
504   /sbin/telinit q ; eend $?
505 fi
506 }
507 # }}}
508
509 # activate serial console {{{
510 config_console(){
511 if checkbootparam "console"; then
512   einfo "Bootoption (for serial) console detected."
513   eindent
514     if [ -r /etc/mgetty/mgetty.config ] ; then
515        MODE=$(getbootparam console | awk -F, '{print $2}')
516        MODE=${MODE%%n*}
517        [ -n "$MODE" ] || MODE=9600 # default mode
518        einfo "Setting speed in /etc/mgetty/mgetty.config to $MODE bps"
519        sed -i "s/speed [0-9]*/speed $MODE/" /etc/mgetty/mgetty.config ; eend $?
520     fi
521
522     einfo "Activating mgetty."
523     sed -i 's/^#T0/T0/' /etc/inittab
524     sed -i 's/^#T1/T1/' /etc/inittab
525     /sbin/telinit q ; eend $?
526   eoutdent
527 fi
528 }
529 # }}}
530
531 # For burning on IDE-CD-Roms, k3b (and others) check for special permissions {{{
532 config_cdrom_perm(){
533 CDROMS=""
534 for DEVICE in /proc/ide/hd?; do
535  [ "$(cat $DEVICE/media 2>/dev/null)" = "cdrom" ] && CDROMS="$CDROMS /dev/${DEVICE##*/}"
536 done
537 [ -n "$CDROMS" ] && { chown root.cdrom $CDROMS; chmod 666 $CDROMS; } 2>/dev/null
538 }
539 # }}}
540
541 # {{{ Bring up loopback interface now
542 config_local_net(){
543  if [ -z "$INSTALLED" ] ; then
544     if grep -q 'iface lo inet loopback' /etc/network/interfaces 2>/dev/null ; then
545        grep -q lo=lo /etc/network/run/ifstate 2>/dev/null || ifup lo
546     else
547        ifconfig lo up
548     fi
549  fi
550 }
551 # }}}
552
553 # firewire devices {{{
554 # the raw1394 driver does not yet export info into SYSFS,
555 # so let's create raw1394 device manually
556 # http://www.michael-prokop.at/blog/index.php?p=352
557 config_firewire_dev(){
558 if checkbootparam "nofirewiredev" ; then
559   ewarn "Skipping creating some firewire devices as requested on boot commandline." ; eend 0
560 else
561 #if [ "${KERNEL%-*}" == "2.6.11" ] ; then
562   einfo "Creating some firewire devices (fix kernel 2.6-bug)."
563 #  cd /dev && MAKEDEV video1394 raw1394
564   [ -r /dev/raw1394 ]   || mknod /dev/raw1394 c 171 0
565   [ -r /dev/video1394 ] || mknod -m 666 /dev/video1394 c 171 16
566 # mknod -m 666 /dev/dv1394 c 171 32 # for NTSC
567   [ -r /dev/dv1394 ]    || mknod -m 666 /dev/dv1394 c 171 34 # for PAL
568   chown -R root:video /dev/raw1394 /dev/video1394 /dev/dv1394
569   chmod -R 664 /dev/raw1394 /dev/video1394 /dev/dv1394 ; eend $?
570 fi
571 #fi
572 }
573 # }}}
574
575 # {{{ copy passwd-lockfile to ramdisk (fix unionfs-behaviour)
576 # otherwise we will get: passwd: Authentication token lock busy
577 config_fix_passwd(){
578  if [ -z "$INSTALLED" ] ; then
579   touch /etc/.pwd.lock
580  fi
581 }
582 # }}}
583
584 # {{{ CD Checker
585 config_testcd(){
586 if [ -n "$TESTCD" ]; then
587   einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
588   einfo "Reading files and checking against GRML/md5sums, this may take a while..."
589   echo -n "${RED}"
590   ( cd /cdrom/GRML/ ; rm -f /tmp/md5sum.log ; md5sum -c md5sums 2>&1 | tee /tmp/md5sum.log )
591   if [ "$?" = "0" ]; then
592     echo " ${GREEN}Everything looks OK${NORMAL}"
593     else
594     echo "${RED} *** CHECKSUM FAILED FOR THESE FILES:                          ***"
595     egrep -v '(^md5sum:|OK$)' /tmp/md5sum.log
596     echo "${RED} *** DATA ON YOUR CD MEDIUM IS POSSIBLY INCOMPLETE OR DAMAGED, ***${NORMAL}"
597     echo "${RED} *** OR YOUR COMPUTER HAS BAD RAM.                             ***${NORMAL}"
598     echo -n "${CYAN}Hit return to contine, or press the reset button to quit.${NORMAL}\a\a\a "
599     read a
600   fi
601   eend 0
602 fi
603 }
604 # }}}
605
606 # {{{ hardware detection via discover
607 config_discover(){
608 if checkbootparam "nodisc" ; then
609   ewarn "Skipping hardware detection via discover as requested on boot commandline." ; eend 0
610 else
611  if [ -x /sbin/discover ] ; then
612   einfo "Discovering hardware. Trying to load the following modules in background:"
613    eindent
614    einfo "$(discover --data-path=linux/module/name --data-path=linux/modules/options --format="%s %s" --data-version=`uname -r` --enable-bus all | sort -u | xargs echo)"
615    eoutdent
616   /sbin/discover-modprobe -v 1>>$DEBUG 2>&1 &
617   eend 0
618  else
619   eerror "Application discover not available. Information: udev should handle hardware recognition." ; eend 0
620  fi
621 fi
622 }
623 # }}}
624
625 # {{{ hardware detection via hwinfo
626 config_hwinfo(){
627 if checkbootparam hwinfo >>$DEBUG 2>&1; then
628   einfo "Discovering hardware via hwinfo:"
629   MODULES=$(su grml hwinfo | grep "Cmd: \"modprobe" | awk '{print $5}' | sed 's/"//')
630   echo -n "  Loading modules: "
631   for i in `echo $MODULES` ; do echo -n $i && modprobe $i ; done
632   eend 0
633 fi
634 }
635 # }}}
636
637 # {{{ disable hotplug agents on request
638 config_hotplug_agent(){
639 if checkbootparam "noagent" ; then
640   AGENT="$(getbootparam 'noagent' 2>>$DEBUG)"
641   AGENTLIST=$(echo "$AGENT" | sed 's/,/\\n/g')
642   AGENTNL=$(echo "$AGENT" | sed 's/,/ /g')
643   einfo "Disabling hotplug-agent(s) $AGENTNL"
644   for agent in $(echo -e $AGENTLIST) ; do
645     mv /etc/hotplug/${agent}.rc /etc/hotplug/${agent}.norc
646   done
647   [ "$?" == "0" ] ; eend $?
648 fi
649 }
650 # }}}
651
652 # {{{ blacklist of hotplug-modules
653 config_hotplug_blacklist(){
654 if checkbootparam "black" ; then
655   BLACK="$(getbootparam 'black' 2>>$DEBUG)"
656   BLACKLIST=$(echo "$BLACK" | sed 's/,/\\n/g')
657   BLACKNL=$(echo "$BLACK" | sed 's/,/ /g')
658   einfo "Blacklisting $BLACKNL via /etc/hotplug/blacklist.d/hotplug-light"
659   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist.d/hotplug-light
660   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist
661   eend 0
662 fi
663 }
664 # }}}
665
666 # {{{ run hotplug
667 config_hotplug(){
668 if checkbootparam "nohotplug" ; then
669   ewarn "Skipping running hotplug as requested on boot commandline." ; eend 0
670 else
671   if [ -r /etc/init.d/hotplug ] ; then
672     einfo "Starting hotplug system in background."
673     /etc/init.d/hotplug start 1>>$DEBUG 2>>$DEBUG &
674     eend 0
675   elif [ -r /etc/init.d/hotplug-light ] ; then
676     einfo "Starting hotplug-light system in background."
677     /etc/init.d/hotplug-light start 1>>$DEBUG 2>>$DEBUG &
678     eend 0
679   else
680     ewarn "No hotplug system found. Should be handled by udev. Skipping execution." ; eend 0
681   fi
682 fi
683 }
684 # }}}
685
686 # {{{ blacklist specific module [ used in /etc/init.d/udev ]
687 config_blacklist(){
688 if checkbootparam "blacklist" ; then
689  if [ -z "$INSTALLED" ]; then
690   einfo "Bootoption blacklist found."
691   BLACK="$(getbootparam 'blacklist' 2>>$DEBUG)"
692   if [ -n "$BLACK" ] ; then
693     einfo "Blacklisting module ${BLACK} via /etc/modprobe.d/grml."
694     echo "# begin entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml
695     echo "blacklist $BLACK"     >> /etc/modprobe.d/grml
696     echo "alias     $BLACK off" >> /etc/modprobe.d/grml
697     echo "# end   entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml ; eend $?
698   else
699    eerror "No given module for blacklist found. Blacklisting will not work therefor."
700   fi
701  else
702   ewarn "Backlisting via bootoption does not work on harddisk installations." ; eend 1
703   eindent
704    einfo "Please blacklist the module(s) via /etc/modprobe.d/blacklist."
705   eoutdent
706  fi
707 fi
708 }
709 # }}}
710
711 # {{{ ACPI
712 config_acpi_apm(){
713 if [ -d /proc/acpi ]; then
714   if checkbootparam "noacpi"; then
715     ewarn "Skipping ACPI Bios detection as requested on boot commandline." ; eend 0
716   else
717     einfo "ACPI Bios found, activating modules: "
718     eindent
719     found=""
720     for a in /lib/modules/$KERNEL/kernel/drivers/acpi/*; do
721       basename="${a##*/}"
722       basename="${basename%%.*}"
723       case "$basename" in *_acpi)
724        egrep -qi "${basename%%_acpi}" /proc/acpi/dsdt 2>>$DEBUG || continue ;;
725       esac
726       modprobe $basename >>$DEBUG 2>&1 && found="yes"
727       local BASE="$BASE $basename"
728     done
729     if [ -n "$found" ] ; then
730       einfo "$BASE"  ; eend 0
731     else
732       ewarn "(none)" ; eend 1
733     fi
734     if ! [ -S /var/run/acpid.socket ] ; then
735       if ! [ -r /var/run/dbus/pid ] ; then
736         einfo "Starting acpi daemon."
737         /etc/init.d/acpid start >>$DEBUG ; eend $?
738       else
739         eerror "acpid error: it seems you are running d-bus/hal, but acpid needs to be started before d-bus."
740         eerror "Solution: please activate acpid via /etc/runlevel.conf"
741         eend 1
742       fi
743     else
744       ewarn "acpi daemon already running."
745       eend 0
746     fi
747     eoutdent
748   fi
749 else
750 # APM
751   if checkbootparam "noapm"; then
752     ewarn "Skipping APM Bios detection as requested on boot commandline." ; eend 0
753   else
754     modprobe apm power_off=1 >>$DEBUG 2>&1
755     if [ "$?" = "0" ] ; then
756        if [ -x /etc/init.d/apmd ] ;then
757           einfo "APM Bios found, enabling power management functions."
758           /etc/init.d/apmd start ; eend $?
759        fi
760     else
761       eerror "Loading apm module failed." ; eend 1
762     fi
763   fi
764 fi
765 }
766 # }}}
767
768 # {{{ PCMCIA Check/Setup
769 # This needs to be done before other modules are being loaded (by hwsetup)
770 config_pcmcia(){
771 if checkbootparam "nopcmcia"; then
772   ewarn "Skipping PCMCIA detection as requested on boot commandline." ; eend 0
773 else
774   if /usr/sbin/laptop-detect ; then
775     einfo "Detected Laptop - checking for PCMCIA." && eend 0
776     modprobe pcmcia_core >>$DEBUG 2>&1
777     # Try Cardbus or normal PCMCIA socket drivers
778     modprobe yenta_socket >>$DEBUG 2>&1 || modprobe i82365 >>$DEBUG 2>&1 || modprobe pd6729 >>$DEBUG 2>&1 || modprobe tcic >>$DEBUG 2>&1
779     if [ "$?" = "0" ]; then
780       modprobe ds >>$DEBUG 2>&1
781       if [ -d /proc/bus/pccard ] ; then
782        if [ -x /sbin/cardmgr ] ; then
783         einfo "PCMCIA found, starting cardmgr."
784         cardmgr >>$DEBUG 2>&1 && sleep 6 && eend 0
785        else
786         eerror "No cardmgr found. Make sure package pcmciautils is installed, it should handle it instead." ; eend 1
787        fi
788       fi
789     fi
790   fi
791 fi
792 }
793 # }}}
794
795 # {{{ run software synthesizer via speakup
796 config_swspeak(){
797 if checkbootparam swspeak ; then
798  if [ -d /proc/speakup/ ] ; then
799   einfo "Bootoption swspeak found. Kernel supports speakup." ; eend 0
800   eindent
801    if [ -x /etc/init.d/speech-dispatcher ] ; then
802      einfo "Starting speech-dispatcher."
803      /etc/init.d/speech-dispatcher start 1>>DEBUG ; eend $?
804      einfo "Activating sftsyn in Kernel."
805      echo sftsyn >/proc/speakup/synth_name ; eend $?
806      einfo "Just run swspeak if you want to use software synthesizer via speakup."
807      flite -o play -t "Finished activating software speakup. Just run swspeak when booting finished."
808    else
809     eerror "speech-dispatcher not available. swspeak will not work without it." ; eend 1
810     flite -o play -t "speech-dispatcher not available. speakup will not work without it."
811    fi
812   eoutdent
813  else
814   eerror "Kernel does not seem to support speakup. Skipping swspeak." ; eend 1
815   flite -o play -t "Kernel does not seem to support speakup. Sorry."
816  fi
817 fi
818 }
819 # }}}
820
821 # {{{ Check for blind option or brltty
822 config_blind(){
823 BLIND=""
824 checkbootparam "blind" && BLIND="yes"
825 BRLTTY="$(getbootparam brltty 2>>$DEBUG)"
826
827 if [ -n "$BLIND" -o -n "$BRLTTY" ]; then
828   if [ -x /sbin/brltty ]; then
829     # Blind option detected, start brltty now.
830     # modprobe serial_core parport_serial generic_serial && echo "done"
831     CMD=brltty
832     BRLTYPE=""
833     BRLDEV=""
834     BRLTEXT=""
835     if [ -n "$BRLTTY" ]; then
836       # Extra options
837       BRLTYPE="${BRLTTY%%,*}"
838       R="${BRLTTY#*,}"
839       if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
840         BRLTTY="$R"
841         BRLDEV="${BRLTTY%%,*}"
842         R="${BRLTTY#*,}"
843         if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
844           BRLTTY="$R"
845           BRLTEXT="${BRLTTY%%,*}"
846           R="${BRLTTY#*,}"
847         fi
848       fi
849     fi
850     [ -n "$BRLTYPE" ] && CMD="$CMD -b $BRLTYPE"
851     [ -n "$BRLDEV"  ] && CMD="$CMD -d $BRLDEV"
852     [ -n "$BRLTEXT" ] && CMD="$CMD -t $BRLTEXT"
853     einfo "Starting braille-display manager."
854 #    ( exec $CMD & )
855     ( sh -c "$CMD" & )
856     sleep 2 && BLINDSOUND="yes"
857     eend 0
858   fi
859 fi
860 }
861 # }}}
862
863 # {{{ Interactive configuration
864 config_interactive(){
865 if [ -n "$INTERACTIVE" ] ; then
866 einfo "Entering interactive configuration second stage."
867
868   echo " ${GREEN}Your console keyboard defaults to: ${MAGENTA}${KEYTABLE}"
869   echo -n "${CYAN}Do you want to (re)configure your console keyboard?${NORMAL} [Y/n] "
870   read a
871   [ "$a" != "n" ] && /usr/sbin/dpkg-reconfigure console-data ; eend $?
872
873   echo -n "${CYAN}Do you want to (re)configure your soundcard?${NORMAL} [Y/n] "
874   read a
875   [ "$a" != "n" ] && alsaconf && ( exec aumix -m 0 >>$DEBUG 2>&1 & ) ; eend $?
876
877   echo -n "${CYAN}Do you want to (re)configure your graphics (X11) subsystem?${NORMAL} [Y/n] "
878   read a
879   [ "$a" != "n" ] && xorgcfg -textmode ; eend $?
880   echo " ${GREEN}Interactive configuration finished. Everything else should be fine for now.${NORMAL}"
881 fi
882 eend 0
883 }
884 # }}}
885
886 # {{{ AGP
887 config_agp(){
888 if checkbootparam forceagp ; then
889 # Probe for AGP. Hope this can fail safely
890   stringinfile "AGP" "/proc/pci" 2>>$DEBUG && { modprobe agpgart || modprobe agpgart agp_try_unsupported=1; } >>$DEBUG 2>&1 && einfo "AGP bridge detected." ; eend 0
891 fi
892 }
893 # }}}
894
895 # {{{ automount(er)
896 config_automounter(){
897 if checkbootparam automounter ; then
898   RUNLEVEL="$(runlevel)"
899   AUTOMOUNTER=""
900   [ -x /etc/init.d/autofs ] && [ "$RUNLEVEL" != "N 1" ] && [ "$RUNLEVEL" != "N S" ] && AUTOMOUNTER="yes"
901
902 addautomount(){
903 # /dev/ice  options
904   d="${1##*/}"
905   if [ -n "$AUTOMOUNTER" ]; then
906     [ -d "/mnt/$d" -a ! -L "/mnt/$d" ] && rmdir /mnt/$d
907     [ -d "/mnt/auto/$d" ] || mkdir -p "/mnt/auto/$d"
908     [ -L "/mnt/$d" ]      || ln -s "/mnt/auto/$d" "/mnt/$d"
909     anew="$d        -fstype=auto,$2 :$i"
910     stringinfile "$anew" "/etc/auto.mnt" || echo "$anew" >> /etc/auto.mnt
911     AUTOMOUNTS="$AUTOMOUNTS $d"
912     new="$1 /mnt/auto/$d  auto   users,noauto,exec,$2 0 0"
913   else
914     [ -d /mnt/$d ] && mkdir -p /mnt/$d
915     new="$1 /mnt/$d  auto   users,noauto,exec,$2 0 0"
916   fi
917   stringinfile "$new" "/etc/fstab" || echo "$new" >> /etc/fstab
918 }
919
920   AUTOMOUNTS="floppy cdrom"
921 # Add new devices to /etc/fstab and /etc/auto.mnt
922   for i in /dev/cdrom?*; do
923     if [ -L $i ]; then
924       addautomount "$i" "ro"
925     fi
926   done
927 fi
928
929 if [ -n "$AUTOMOUNTER" ]; then
930 # Check for floppy dir, reinstall with automounter
931   [ -d /mnt/floppy -a ! -L /mnt/floppy ] && rmdir /mnt/floppy
932   [ -d /mnt/auto/floppy ] || mkdir -p /mnt/auto/floppy
933   [ -L /mnt/floppy ] || ln -s /mnt/auto/floppy /mnt/floppy
934   [ -d /mnt/cdrom -a ! -L /mnt/cdrom ] && rmdir /mnt/cdrom
935   [ -d /mnt/auto/cdrom ] || mkdir -p /mnt/auto/cdrom
936   [ -L /mnt/cdrom ] || ln -s /mnt/auto/cdrom /mnt/cdrom
937   rm -f /etc/fstab.new
938 # Replace paths from bootfloppy
939   sed 's|/mnt/cdrom|/mnt/auto/cdrom|g;s|/mnt/floppy|/mnt/auto/floppy|g' /etc/fstab > /etc/fstab.new
940   mv -f /etc/fstab.new /etc/fstab
941 # Start automounter now
942   einfo "Starting automounter for ${AUTOMOUNTS}."
943   /etc/init.d/autofs start >>$DEBUG ; eend $?
944 fi
945 }
946 # }}}
947
948 # {{{ Collect partitions from /proc/partitions first for enabling DMA
949 check_partitions(){
950 partitions=""
951 IDEDISKS=""
952 while read major minor blocks partition relax; do
953   partition="${partition##*/}"
954   [ -z "$partition" -o ! -e "/dev/$partition" ] && continue
955   case "$partition" in
956     hd?) IDEDISKS="$IDEDISKS $partition";;                # IDE  Harddisk, entire disk
957     sd?) ;;                                               # SCSI Harddisk, entire disk
958 #    [hs]d*) partitions="$partitions /dev/$partition";;    # IDE or SCSI disk partition
959     [hs]d*|ub*) partitions="$partitions /dev/$partition";;    # IDE, USB or SCSI disk partition
960   esac
961 done <<EOT
962 $(awk 'BEGIN{old="__start"}{if($0==old){exit}else{old=$0;if($4&&$4!="name"){print $0}}}' /proc/partitions)
963 EOT
964 }
965 check_partitions 1>/dev/null 2>&1 # avoid output "check_partitions:3: read-only file system"
966 # }}}
967
968 # {{{ Enable DMA for all IDE drives now if not disabled
969 # Notice: Already done by linuxrc, but make sure it's done also on harddisk-installed systems
970 config_dma(){
971 if checkbootparam "nodma"; then
972   ewarn "Skipping DMA accelleration as requested on boot commandline." ; eend 0
973 else
974   for d in $(cd /proc/ide 2>>$DEBUG && echo hd[a-z]); do
975     if test -d /proc/ide/$d; then
976       if egrep -q 'using_dma[ \t]+0' /proc/ide/$d/settings 2>>$DEBUG; then
977         MODEL="$(cat /proc/ide/$d/model 2>>$DEBUG)"
978         test -z "$MODEL" && MODEL="[GENERIC IDE DEVICE]"
979         einfo "Enabling DMA acceleration for: ${WHITE}$d        ${YELLOW}[${MODEL}]${NORMAL}"
980         echo "using_dma:1" >/proc/ide/$d/settings
981         eend 0
982       fi
983     fi
984   done
985 fi
986 }
987 # }}}
988
989 # {{{ Start creating /etc/fstab with HD partitions and USB SCSI devices now
990 config_fstab(){
991
992 NOSWAP="yes" # we do not use swap by default!
993 if checkbootparam "swap" -o checkbootparam "anyswap" ; then
994    NOSWAP=''
995 fi
996
997 if checkbootparam "nofstab" -o checkbootparam "forensic" ; then
998   ewarn "Skipping /etc/fstab creation as requested on boot commandline." ; eend 0
999 else
1000   checkbootparam "anyswap" && export ANYSWAP='yes' || export ANYSWAP=""
1001   einfo "Scanning for harddisk partitions and creating /etc/fstab. (Disable this via boot option: nofstab)"
1002   iszsh && setopt nonomatch
1003   if [ -x /usr/sbin/rebuildfstab ] ; then
1004     config_userfstab || fstabuser=grml
1005     /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
1006   else
1007     ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
1008   fi
1009   if [ -e /var/run/rebuildfstab.pid ]; then
1010     # Another instance of rebuildfstab, probably from hotplug, is still running, so just wait.
1011     sleep 8
1012   fi
1013 fi
1014 # Scan for swap, config, homedir
1015 if [ -z "$NOSWAP" ]; then
1016    einfo "Searching for swap partition(s) as requested."
1017 fi
1018 GRML_IMG=""
1019 GRML_SWP=""
1020 HOMEDIR="$(getbootparam home)"
1021 if [ -n "$partitions" ]; then
1022  while read p m f relax; do
1023   case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
1024   partoptions="users,exec"
1025   fnew=""
1026   case "$f" in swap)
1027    eindent
1028    if [ -n "$NOSWAP" ]; then
1029       if [ -z "$INSTALLED" ] ; then
1030          ewarn "Ignoring swap partition ${WHITE}$p${NORMAL}. (Force usage via boot option 'swap', or execute grml-swapon)" ; eend 0
1031       fi
1032    else
1033      case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
1034              S1SUSP|S2SUSP|pmdisk|[zZ]*)
1035                 if [ -n "$ANYSWAP" ] ; then
1036                   einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
1037                   swapon $p 2>>$DEBUG ; eend $?
1038                 else
1039                   ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
1040                 fi
1041                ;;
1042              *)
1043                 if [[ "$p" == LABEL* ]] ; then
1044                    p=$(blkid -t $p | awk -F: '{print $1}')
1045                 fi
1046                 if grep -q $p /proc/swaps ; then
1047                    ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
1048                 else
1049                    einfo "Using swap partition ${WHITE}${p}${NORMAL}."
1050                    swapon $p 2>>$DEBUG ; eend $?
1051                 fi
1052                ;;
1053      esac
1054    fi
1055    eoutdent
1056    continue
1057    ;;
1058   esac
1059 # Create mountdir if not already present, but don't try to create stuff like /proc/bus/usb
1060 # Notice: grml-rebuildfstab >= 0.3-1 handles this now
1061 #  case "$m" in *none*|*proc*|*sys*|'') continue ;; esac
1062 #  [ -d "$m" ] || mkdir -p "$m"
1063 # WARNING: NTFS RW mounts are only safe since Kernel 2.6.11
1064   [ "$f" = "ntfs" -a "${KERNEL%.*}" != "2.6" ] && continue
1065   MOUNTOPTS="ro"
1066   case "$f" in
1067     vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
1068     ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
1069     *) continue ;;
1070     # *) NONEFOUND='1'; continue ;;
1071   esac
1072   if [ -z "$NOSWAP" ] ; then
1073      mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG || continue
1074      # Activate swapfile, if exists
1075      SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
1076   fi
1077   if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
1078    mount -o remount,rw $m
1079    if swapon "$SWAPFILE" 2>>$DEBUG ; then
1080     einfo "Using GRML swapfile ${SWAPFILE}."
1081     fnew="$SWAPFILE swap swap defaults 0 0"
1082     stringinfile "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
1083     GRML_SWP="$GRML_SWP $SWAPFILE"
1084     eend 0
1085    fi
1086    mount -o remount,ro $m 2>>$DEBUG
1087   fi
1088   IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
1089   if [ -z "$INSTALLED" -a -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
1090    if [ -n "$HOMEDIR" ]; then
1091     if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
1092      continue
1093     fi
1094    fi
1095    if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
1096     GRML_IMG="$IMAGE"
1097     mount -o remount,ro $m 2>>$DEBUG
1098    fi
1099   fi
1100   eend 0
1101   # Umount, if not in use
1102   umount -r $m 2>/dev/null
1103  done <<EOT
1104 $(cat /etc/fstab)
1105 EOT
1106 fi
1107 }
1108 # }}}
1109
1110 # {{{ Mouse
1111 config_mouse(){
1112 if [ -n "$MOUSE_DEVICE" ] ; then
1113   einfo "Detecting mouse: ${MOUSE_FULLNAME} at ${MOUSE_DEVICE}" ; eend $?
1114 fi
1115 }
1116 # }}}
1117
1118 # {{{ IPv6 configuration
1119 # Load IPv6 kernel module and print IP adresses
1120 config_ipv6(){
1121 if checkbootparam "ipv6"; then
1122   einfo "Enabling IPv6 as requested on boot commandline (sleeping for 2 seconds)"
1123   modprobe ipv6
1124   # we probably need some time until stateless autoconfiguration has happened
1125   sleep 2
1126   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1127   for DEVICE in `echo "$NETDEVICES"`; do
1128     eindent
1129       einfo "$DEVICE:"
1130       ADDRESSES="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{print $3}')"
1131       COUNT="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{ sum += 1};END {print sum }')"
1132       eindent
1133         for ADDR in `echo "$ADDRESSES"` ; do
1134             einfo "$ADDR"
1135         done
1136         if [ "$COUNT" -eq "0" ] ; then
1137            einfo "(none)" ; eend 1
1138         fi
1139       eoutdent
1140     eoutdent
1141   done
1142   eend 0
1143 fi
1144 }
1145 # }}}
1146
1147 # {{{ Fat-Client-Version: DHCP Broadcast for IP address
1148 config_dhcp(){
1149 if checkbootparam "nodhcp"; then
1150   ewarn "Skipping DHCP broadcast/network detection as requested on boot commandline." ; eend 0
1151 else
1152   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1153   rm -rf /etc/network/status ; mkdir -p /etc/network/status
1154   for DEVICE in `echo "$NETDEVICES"` ; do
1155     einfo "Network device ${WHITE}${DEVICE}${NORMAL} detected, DHCP broadcasting for IP. (Backgrounding)"
1156     trap 2 3 11
1157     ifconfig $DEVICE up >>$DEBUG 2>&1
1158     ( pump -i $DEVICE >>$DEBUG 2>&1 && echo finished_running_pump > /etc/network/status/$DEVICE ) &
1159     trap "" 2 3 11
1160     sleep 1
1161     eend 0
1162   done
1163 fi
1164 }
1165 # }}}
1166
1167 # {{{ helper functions
1168 findfile(){
1169 FOUND=""
1170 # search all partitions for a file in the root directory
1171 for i in /mnt/[sh]d[a-z] /mnt/[sh]d[a-z][1-9] /mnt/[sh]d[a-z][1-9]?*; do
1172 # See if it's already mounted
1173   [ -f "$i/$1" ] &&  { echo "$i/$1"; return 0; }
1174   if [ -d "$i" ] && mount -r "$i" 2>>$DEBUG; then
1175     [ -f "$i/$1" ] && FOUND="$i/$1"
1176     umount -l "$i" 2>>$DEBUG
1177     [ -n "$FOUND" ] && { echo "$FOUND"; return 0; }
1178   fi
1179 done
1180 return 2
1181 }
1182
1183 fstype(){
1184 case "$(file -s $1)" in
1185   *[Ff][Aa][Tt]*|*[Xx]86*) echo "vfat"; return 0;;
1186   *[Rr][Ee][Ii][Ss][Ee][Rr]*)  echo "reiserfs"; return 0;;
1187   *[Xx][Ff][Ss]*)  echo "xfs"; return 0;;
1188   *[Ee][Xx][Tt]3*) echo "ext3"; return 0;;
1189   *[Ee][Xx][Tt]2*) echo "ext2"; return 0;;
1190   *data*)          echo "invalid"; return 0;;
1191   *) echo "auto"; return 0;;
1192 esac
1193 }
1194
1195 # Try to mount this filesystem read-only, without or with encryption
1196 trymount(){
1197 # Check if already mounted
1198 case "$(cat /proc/mounts)" in *\ $2\ *) return 0;; esac
1199 # Apparently, mount-aes DOES autodetect AES loopback files.
1200 [ -b "$1" ] && { mount -t auto -o ro "$1" "$2" 2>>$DEBUG; RC="$?"; }
1201 # We need to mount crypto-loop files with initial rw support
1202 [ -f "$1" ] && { mount -t auto -o loop,rw "$1" "$2" 2>>$DEBUG; RC="$?"; }
1203 # Mount succeeded?
1204 [ "$RC" = "0" ] && return 0
1205 echo ""
1206 einfo "Filesystem not autodetected, trying to mount $1 with AES256 encryption."
1207 a="y"
1208 while [ "$a" != "n" -a "$a" != "N" ]; do
1209 # We need to mount crypto-loop files with initial rw support
1210  mount -t auto -o loop,rw,encryption=AES256 "$1" "$2" && return 0
1211  echo -n "${RED}Mount failed, retry? [Y/n] ${NORMAL}"
1212  # Problem with ioctl() from getpasswd()?
1213  # read a
1214  read a
1215 done
1216 return 1
1217 }
1218 # }}}
1219
1220 # {{{ CPU-detection
1221 config_cpu(){
1222 if checkbootparam "nocpu"; then
1223   ewarn "Skipping CPU detection as requested on boot commandline." ; eend 0
1224 else
1225   # check module dependencies
1226   cpufreq_check() {
1227    if [ -e /lib64 ] ; then
1228       [ -e /lib/modules/${KERNEL}/kernel/arch/x86_64/kernel/cpufreq ] || return 1
1229    else
1230       [ -e /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq -o ! -e /lib/modules/${KERNEL}/kernel/drivers/cpufreq ] || return 1
1231    fi
1232   }
1233
1234   if [[ `grep -c processor /proc/cpuinfo` -gt 1 ]] ; then
1235      einfo "Detecting CPU:"
1236      CPU=$(awk -F: '/^processor/{printf "       Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
1237      echo $CPU | sed 's/ \{1,\}/ /g'
1238      eend 0
1239   else
1240      einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
1241   fi
1242
1243   if ! cpufreq_check ; then
1244     ewarn "Skipping cpufreq setup as module dependencies are not fulfilled." ; eend 1
1245   else
1246     if /usr/sbin/laptop-detect ; then
1247        einfo "Detected Laptop - trying to use cpu frequency scaling:"
1248        if [ -r /usr/bin/cpufreq-detect.sh ] ; then
1249           eindent
1250           . /usr/bin/cpufreq-detect.sh
1251           if [ -n "$MODULE" -a "$MODULE" != none ]; then
1252              einfo "Loading modules ${MODULE} and cpufreq_ondemand, setting ondemand governor"
1253              modprobe "$MODULE" 1>>$DEBUG || modprobe "$MODULE_FALLBACK" 1>>$DEBUG
1254              if modprobe cpufreq_ondemand && RC=0 || RC=1 ; then
1255                 for file in $(find /sys/devices/system/cpu/ -name scaling_governor 2>/dev/null) ; do
1256                     echo ondemand > $file
1257                 done
1258              fi
1259              eend $RC
1260           else
1261              ewarn "Could not detect an appropriate CPU for use with cpu frequency scaling - skipping." && eend 1
1262           fi
1263           eoutdent
1264        fi # cpufreq-detect
1265     fi # laptop-detect
1266   fi # cpufreq_check
1267 fi # checkbootparam nocpu
1268 }
1269 # }}}
1270
1271 # {{{ autostart of ssh
1272 config_ssh(){
1273 if checkbootparam ssh ; then
1274   SSH_PASSWD="$(getbootparam 'ssh' 2>>$DEBUG)"
1275   einfo "Bootoption passwd found."
1276   if [ -n "$SSH_PASSWD" ] ; then
1277     echo "grml:$SSH_PASSWD" | chpasswd -m
1278     einfo "Starting secure shell server in background."
1279     /etc/init.d/rmnologin start 1>>$DEBUG 2>>$DEBUG
1280     /etc/init.d/ssh start 1>>$DEBUG 2>>$DEBUG &
1281     eend 0
1282   else
1283     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1284   fi
1285   eindent
1286     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1287   eoutdent
1288 fi
1289 }
1290 # }}}
1291
1292 # {{{ set password for user grml
1293 config_passwd(){
1294 if checkbootparam passwd >>$DEBUG 2>&1; then
1295   einfo "Bootoption passwd found."
1296   PASSWD="$(getbootparam 'passwd' 2>>$DEBUG)"
1297   if [ -n "$PASSWD" ] ; then
1298     echo "grml:$PASSWD" | chpasswd -m ; eend $?
1299   else
1300     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1301   fi
1302   eindent
1303     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1304   eoutdent
1305 fi
1306 }
1307 # }}}
1308
1309 # {{{ Check for persistent homedir option and eventually mount /home from there, or use a loopback file.
1310 config_homedir(){
1311 if checkbootparam home ; then
1312 HOMEDIR="$(getbootparam home)"
1313 MYHOMEDEVICE=""
1314 MYHOMEMOUNTPOINT=""
1315 MYHOMEDIR=""
1316 if [ -n "$HOMEDIR" ]; then
1317   einfo "Bootoption home detected." && eend 0
1318   case "$HOMEDIR" in
1319     /dev/*)
1320     MYHOMEDEVICE="${HOMEDIR##/dev/}"
1321     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1322     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1323     MYHOMEDIR="/mnt/${HOMEDIR##/dev/}"
1324   ;;
1325     /mnt/*)
1326     MYHOMEDEVICE="${HOMEDIR##/mnt/}"
1327     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1328     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1329     MYHOMEDIR="$HOMEDIR"
1330   ;;
1331     [Aa][Uu][Tt][Oo]|[Ss][Cc][Aa][Nn]|[Ff][Ii][Nn][Dd])
1332     MYHOMEDIR="$(findfile grml.img)"
1333     MYHOMEDEVICE="${MYHOMEDIR##/mnt/}"
1334     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1335     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1336   ;;
1337   *)
1338     eerror "Invalid home= option '$HOMEDIR' specified (must start with /dev/ or /mnt/ or 'scan')." ; eend 1
1339     eerror "Option ignored." ; eend 1
1340   ;;
1341   esac
1342 fi
1343
1344 if [ -n "$MYHOMEDIR" ]; then
1345   if trymount "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"; then
1346     [ -f "$MYHOMEMOUNTPOINT/grml.img" ] && MYHOMEDIR="$MYHOMEMOUNTPOINT/grml.img"
1347     while read device mountpoint fs relax; do
1348       case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
1349         case "$fs" in *[Nn][Tt][Ff][Ss]*)
1350           umount "$MYHOMEMOUNTPOINT"; eerror "Error: will not mount NTFS filesystem on $MYHOMEDEVICE read/write!" ; eend 1
1351           break
1352         ;;
1353         *[Ff][Aa][Tt]*)
1354         # Note: This currently won't work with encrypted partitions
1355         umount "$MYHOMEMOUNTPOINT"; mount -t vfat -o rw,uid=grml,gid=grml,umask=002 "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"
1356         if [ ! -f "$MYHOMEDIR" ]; then
1357           ewarn "WARNING: FAT32 is not a good filesystem option for /home/grml (missing socket/symlink support)."
1358           ewarn "WARNING: Better use an ext2 loopback file on this device, and boot with home=$MYHOMEDEVICE/grml.img."
1359         fi
1360         ;;
1361       esac
1362       if mount -o remount,rw "$MYHOMEMOUNTPOINT"; then
1363         einfo "Mounting ${WHITE}$MYHOMEDIR${NORMAL} as ${WHITE}/home/grml${NORMAL}."
1364         if [ -f "$MYHOMEDIR" ]; then
1365           # It's a loopback file, mount it over the /home/grml directory
1366           trymount "$MYHOMEDIR" /home/grml
1367           RC="$?"
1368           [ "$RC" = "0" ] && ERROR="$(mount -o remount,rw /home/grml 2>&1)"
1369           RC="$?"
1370         else
1371           # Do a --bind mount
1372           ERROR="$(mount --bind "$MYHOMEDIR" /home/grml 2>&1)"
1373           RC="$?"
1374         fi
1375         [ "$RC" = "0" ] && eend 0 || ( eerror "${ERROR}" ; eend 1 )
1376       fi
1377       break
1378       ;;
1379     esac
1380   done <<EOT
1381 $(cat /proc/mounts)
1382 EOT
1383   fi
1384 fi
1385 fi # checkbootparam home
1386 }
1387 # }}}
1388
1389 # {{{ Check for scripts on CD-ROM
1390 config_cdrom_scripts(){
1391 if checkbootparam "script"; then
1392   for script in /cdrom/scripts/* ; do
1393     einfo " grml script found on CD, executing ${WHITE}${script}${NORMAL}."
1394     . $script
1395   done
1396 fi
1397 }
1398 # }}}
1399
1400 # {{{ Sound
1401 config_mixer(){
1402 if ! [ -x /usr/bin/aumix ] ; then
1403   eerror "aumix binary not available. Can not set sound volumes therefore." ; eend 1
1404 else
1405
1406   if checkbootparam vol ; then
1407     VOL="$(getbootparam 'vol' 2>>$DEBUG)"
1408     if [ -z "$VOL" ] ; then
1409       eerror "Bootoption vol found but no volume level/parameter given. Using defaults." ; eend 1
1410       VOL='75' # default
1411     fi
1412   else
1413     VOL='75' # default
1414   fi
1415
1416   if checkbootparam nosound ; then
1417     einfo "Muting sound devices on request."
1418     # some IBM notebooks require the following stuff:
1419     if [ -x /usr/bin/amixer ] ; then
1420        if amixer get Front 1>/dev/null 2>>$DEBUG ; then
1421           amixer set Front unmute 1>/dev/null
1422           amixer set Front 0% 1>/dev/null
1423        fi
1424     fi
1425     ERROR=$(aumix -w 0 -v 0 -p 0 -m 0 2>&1) ; RC=$?
1426     if [ -n "$ERROR" ] ; then
1427        eindent
1428        eerror "Problem muting sound devices: $ERROR"
1429        eoutdent
1430     fi
1431     eend $RC
1432   elif [ -z "$INSTALLED" ]; then
1433       einfo "Setting mixer volumes to level ${WHITE}${VOL}${NORMAL}."
1434       # some IBM notebooks require the following stuff:
1435       if [ -x /usr/bin/amixer ] ; then
1436          if amixer get Front 1>/dev/null 2>>$DEBUG ; then
1437             amixer set Front unmute 1>/dev/null
1438             amixer set Front ${VOL}% 1>/dev/null
1439          fi
1440       fi
1441       ERROR=$(aumix -w $VOL -v $VOL -p $VOL -m $VOL 2>&1) ; RC=$?
1442       if [ -n "$ERROR" ] ; then
1443          eindent
1444          eerror "Problem setting mixer volumes: $ERROR"
1445          eoutdent
1446       fi
1447       eend $RC
1448   fi
1449
1450 fi
1451 }
1452 # }}}
1453
1454 # {{{ modem detection
1455 config_modem(){
1456 if checkbootparam "nomodem"; then
1457   ewarn "Skipping check for AC97 modem controller as requested on boot commandline." ; eend 0
1458 else
1459   if [ -x /etc/init.d/sl-modem-daemon ] ; then
1460    if lspci | grep Intel | grep -q "AC'97 Modem Controller" ; then
1461      einfo "AC97 modem controller detected. Starting sl-modem-daemon in background."
1462      /etc/init.d/sl-modem-daemon start >>$DEBUG &
1463      eend 0
1464    fi
1465   fi
1466 fi
1467 }
1468 # }}}
1469
1470 # {{{ keyboard add-ons
1471 config_setkeycodes(){
1472 if checkbootparam "setkeycodes" ; then
1473  einfo "Setting keycodes as requested via bootparameter 'setkeycodes'."
1474   # MS MM keyboard add-on
1475   # fix
1476   setkeycodes e001 126 &>/dev/null
1477   setkeycodes e059 127 &>/dev/null
1478   # fn keys
1479   setkeycodes e03b 59 &>/dev/null
1480   setkeycodes e008 60 &>/dev/null
1481   setkeycodes e007 61 &>/dev/null
1482   setkeycodes e03e 62 &>/dev/null
1483   setkeycodes e03f 63 &>/dev/null
1484   setkeycodes e040 64 &>/dev/null
1485   setkeycodes e041 65 &>/dev/null
1486   setkeycodes e042 66 &>/dev/null
1487   setkeycodes e043 67 &>/dev/null
1488   setkeycodes e023 68 &>/dev/null
1489   setkeycodes e057 87 &>/dev/null
1490   setkeycodes e058 88 &>/dev/null
1491   # hp keycodes
1492   setkeycodes e00a 89 e008 90 &>/dev/null
1493  eend 0
1494 fi
1495 }
1496 # }}}
1497
1498 # {{{ wondershaper
1499 config_wondershaper(){
1500  if checkbootparam "wondershaper" ; then
1501     WONDER="$(getbootparam wondershaper 2>>$DEBUG)"
1502     CMD=wondershaper
1503     DEVICE=""
1504     DOWNSTREAM=""
1505     UPSTREAM=""
1506     if [ -n "$WONDER" ]; then
1507       # Extra options
1508       DEVICE="${WONDER%%,*}"
1509       R="${WONDER#*,}"
1510       if [ -n "$R" -a "$R" != "$WONDER" ]; then
1511         WONDER="$R"
1512         DOWNSTREAM="${WONDER%%,*}"
1513         R="${WONDER#*,}"
1514         if [ -n "$R" -a "$R" != "$WONDER" ]; then
1515           WONDER="$R"
1516           UPSTREAM="${WONDER%%,*}"
1517           R="${WONDER#*,}"
1518         fi
1519       fi
1520     fi
1521     [ -n "$DEVICE" ]     && CMD="$CMD $DEVICE"
1522     [ -n "$DOWNSTREAM" ] && CMD="$CMD $DOWNSTREAM"
1523     [ -n "$UPSTREAM" ]   && CMD="$CMD $UPSTREAM"
1524     einfo "Starting wondershaper (${CMD}) in background."
1525     ( sh -c $CMD & ) && eend 0
1526  fi
1527 }
1528 # }}}
1529
1530 # {{{ syslog-ng
1531 config_syslog(){
1532  if checkbootparam "nosyslog"; then
1533   ewarn "Not starting syslog-ng as requested on boot commandline." ; eend 0
1534  else
1535   einfo "Starting syslog-ng in background."
1536   /etc/init.d/syslog-ng start 1>>$DEBUG &
1537   eend 0
1538  fi
1539 }
1540 # }}}
1541
1542 # {{{ gpm
1543 config_gpm(){
1544  if checkbootparam "nogpm"; then
1545   ewarn "Not starting GPM as requested on boot commandline." ; eend 0
1546  else
1547   einfo "Starting gpm in background."
1548 #  /etc/init.d/gpm start 1>>$DEBUG &
1549   ( while [ ! -e /dev/psaux ]; do sleep 5; done; /etc/init.d/gpm start 1>>$DEBUG ) &
1550   eend 0
1551  fi
1552 }
1553 # }}}
1554
1555 # {{{ services
1556 config_services(){
1557  if checkbootparam "services" ; then
1558     SERVICE="$(getbootparam services 2>>$DEBUG)"
1559     SERVICELIST=$(echo "$SERVICE" | sed 's/,/\\n/g')
1560     SERVICENL=$(echo "$SERVICE" | sed 's/,/ /g')
1561     einfo "Starting service(s) ${SERVICENL} in background."
1562     for service in $(echo -e $SERVICELIST) ; do
1563        /etc/init.d/${service} start 1>>$DEBUG &
1564     done
1565     [ "$?" == "0" ] ; eend $?
1566  fi
1567 }
1568 # }}}
1569
1570 # {{{ config files
1571 config_netconfig(){
1572  if checkbootparam netconfig ; then
1573   CONFIG="$(getbootparam 'netconfig' 2>>$DEBUG)"
1574   CONFIGFILE='/tmp/netconfig.grml'
1575
1576   getconfig() {
1577   wget --timeout=10 --dns-timeout=10  --connect-timeout=10 \
1578        --read-timeout=10 $CONFIG -O $CONFIGFILE && return 0 || return 1
1579   }
1580   einfo "Trying to get ${WHITE}${CONFIG}${NORMAL}"
1581   counter=10
1582   while ! getconfig && [[ "$counter" != 0 ]] ; do
1583     echo -n "Sleeping for 5 seconds and trying to get config again... "
1584     counter=$(( counter-1 ))
1585     echo "$counter tries left" ; sleep 1
1586   done
1587   if [ -r "$CONFIGFILE" ] ; then
1588     einfo "Downloading was successfull." ; eend 0
1589     einfo "md5sum of ${WHITE}${CONFIG}${NORMAL}: "
1590     md5sum $CONFIGFILE ; eend 0
1591     cd / && einfo "Unpacking ${WHITE}${CONFIGFILE}${NORMAL}:" && /usr/bin/unp $CONFIGFILE $EXTRACTOPTIONS ; eend $?
1592   else
1593     einfo "Sorry, could not fetch $CONFIG" ; eend 1
1594   fi
1595  fi
1596 }
1597 # }}}
1598
1599 # {{{ blindsound
1600 config_blindsound(){
1601  if checkbootparam "blind" ; then
1602     beep
1603     flite -o play -t "welcome to the gremel system"
1604  fi
1605 }
1606 # }}}
1607
1608 # {{{ welcome sound
1609 config_welcome(){
1610  if checkbootparam welcome ; then
1611   flite -o play -t "welcome to the gremel system"
1612  fi
1613 }
1614 # }}}
1615
1616 # {{{ fix/workaround for unionfs
1617 fix_unionfs(){
1618   if [ -z "$INSTALLED" ]; then
1619    touch /var/cache/apt/*cache.bin
1620   fi
1621 }
1622 # }}}
1623
1624 # {{{ create all /mnt-directories
1625 create_mnt_dirs(){
1626   ewarn "create_mnt_dirs is deprecated as grml-rebuildfstab does all we need."
1627   ewarn "Please set CONFIG_CREATE_MNT_DIRS='no' in /etc/grml/autoconfig" ; eend 0
1628 }
1629 # }}}
1630
1631 # {{{ start X window system via grml-x
1632 config_x_startup(){
1633 if checkbootparam startx ; then
1634  if [ -x /usr/X11R6/bin/X ] ; then
1635   if [ -z "$INSTALLED" ] ; then
1636    WINDOWMANAGER="$(getbootparam 'startx' 2>>$DEBUG)"
1637    if [ -z "$WINDOWMANAGER" ] ; then
1638      einfo "No window manager specified. Taking ${WHITE}wm-ng${NORMAL} as default." && eend 0
1639      WINDOWMANAGER="wm-ng"
1640    else
1641      einfo "Window manager ${WHITE}${WINDOWMANAGER}${NORMAL} found as bootoption." && eend 0
1642    fi
1643    einfo "Changing to runlevel 5 for starting grml-x ${WINDOWMANAGER}. Just exit X windows system to get full featured consoles."
1644    config_userfstab || fstabuser='grml'
1645  cat>|/etc/init.d/xstartup<<EOF
1646 #!/bin/sh
1647 # su - $fstabuser -c 'grml-x "$WINDOWMANAGER"'
1648 sudo -u $fstabuser -i /usr/bin/grml-x $WINDOWMANAGER 1>>$DEBUG
1649 EOF
1650    chmod 755 /etc/init.d/xstartup
1651
1652    sed -i 's#^6:.*#6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"#' /etc/inittab
1653
1654    /sbin/telinit q ; eend $?
1655
1656    if grep -q '^allowed_users=' /etc/X11/Xwrapper.config ; then
1657       sed -i 's/^allowed_users=.*/allowed_users=anybody/' /etc/X11/Xwrapper.config
1658    else
1659       echo 'allowed_users=anybody' >> /etc/X11/Xwrapper.config
1660    fi
1661
1662   else
1663     eerror "We are not running from CD - startx will not work, skipping it.
1664      Please use something like xdm, gdm or kdm for starting X on a harddisk system!" ; eend 1
1665   fi
1666  else
1667    eerror "/usr/X11R6/bin/X is not present on this grml flavour.
1668    Boot parameter startx does not work therefore." ; eend 1
1669  fi
1670 fi
1671 }
1672 # }}}
1673
1674 # {{{ configuration framework
1675 config_extract(){
1676 if checkbootparam extract ; then
1677  EXTRACT="$(getbootparam 'extract' 2>>$DEBUG)"
1678  EXTRACTOPTIONS="-- -x $EXTRACT"
1679 fi
1680 }
1681
1682 config_automount(){
1683 if checkbootparam noautoconfig -o checkbootparam forensic ; then
1684   ewarn "Skipping running automount of device(s) labeled GRMLCFG as requested." ; eend 0
1685 else
1686  if [ -z "$INSTALLED" ] ; then
1687   einfo "Searching for device(s) labeled with GRMLCFG." ; eend 0
1688   eindent
1689   [ -d /mnt/grml ] || mkdir /mnt/grml
1690   umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
1691 # We do need the following fix so floppy disk is available to blkid in any case :-/
1692   if [ -r /dev/fd0 ] ; then
1693      einfo "Floppy device detected. Trying to access floppy disk. (Disable this via boot option: noautoconfig)"
1694 #     dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1
1695      if timeout 4 dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1 ; then
1696         blkid /dev/fd0 1>>$DEBUG 2>&1
1697      fi
1698   fi
1699   DEVICE=$(blkid -t LABEL=GRMLCFG | head -1 | awk -F: '{print $1}')
1700   [ -n "$DEVICE" ] && mount -t auto -o ro $DEVICE /mnt/grml ; RC="$?"
1701   if [[ $RC == 0 ]]; then
1702     einfo "Mounting device $DEVICE labeled GRMLCFG succeeded." ; eend 0
1703
1704     CONFIG=''
1705     CONFIG="$(/bin/ls -1d /mnt/grml/[Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1706     if [ -n "$CONFIG" ]; then
1707       einfo "Found file ${WHITE}${CONFIG}${NORMAL} - trying to extract it."
1708       cd /
1709       unp $CONFIG $EXTRACTOPTIONS ; eend $?
1710     else
1711       ewarn "Sorry, could not find file config.tbz on device with label GRMLCFG." ; eend 1
1712     fi
1713
1714     SCRIPT=''
1715     SCRIPT="$(/bin/ls -1d /mnt/grml/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1716     if [ -n "$SCRIPT" ]; then
1717       einfo "Found script ${WHITE}${SCRIPT}${NORMAL} - trying to execute it."
1718       $SCRIPT ; eend $?
1719     fi
1720     grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1721   else
1722     ewarn "No devices with label GRMLCFG found." ; eend 0
1723   fi
1724   eoutdent
1725  fi
1726 fi
1727 }
1728
1729 config_myconfig(){
1730
1731 if checkbootparam "config" ; then
1732   CONFIG="$(getbootparam 'config' 2>>$DEBUG)"
1733   [ -z "$CONFIG" ] && CONFIG='config.tbz'
1734   einfo "Bootoption config found. config is set to: $CONFIG"
1735   eindent
1736     einfo "Trying to extract configuration file ${CONFIG}:"
1737     cd / && unp /cdrom/config/$CONFIG $EXTRACTOPTIONS ; eend $?
1738   eoutdent
1739 fi
1740
1741 if checkbootparam myconfig ; then
1742  MOUNTDEVICE="$(getbootparam 'myconfig' 2>>$DEBUG)"
1743  if [ -n "$MOUNTDEVICE" ]; then
1744    if checkbootparam file ; then
1745     FILENAME="$(getbootparam 'file' 2>>$DEBUG)"
1746     [ -n "$FILENAME" ] || FILENAME='config.tbz'
1747    fi
1748    [ -d /mnt/grml ] || mkdir /mnt/grml
1749    umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
1750    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1751     if [[ $RC == 0 ]]; then
1752       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1753       eindent
1754       CONFIG=''
1755       CONFIG="$(/bin/ls -1d /mnt/grml/[Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1756       if [ -n "$CONFIG" ]; then
1757         einfo "Found file ${WHITE}${CONFIG}${NORMAL} - trying to extract it."
1758         cd /
1759         unp $CONFIG $EXTRACTOPTIONS ; eend $?
1760       else
1761         ewarn "Sorry, could not find file config.tbz on device with label GRMLCFG." ; eend 1
1762       fi
1763
1764       SCRIPT=''
1765       SCRIPT="$(/bin/ls -1d /mnt/grml/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1766       if [ -n "$SCRIPT" ]; then
1767         einfo "Found script ${WHITE}${SCRIPT}${NORMAL} - trying to execute it."
1768         $SCRIPT ; eend $?
1769       fi
1770       eoutdent
1771     else
1772       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1773     fi # mount $MOUNTDEVICE
1774    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1775  else
1776    einfo "Sorry, no device for bootoption myconfig provided. Skipping." ; eend 1
1777  fi # [ -n "$MOUNTDEVICE" ]
1778 fi # checkbootparam myconfig
1779
1780 if checkbootparam "partconf" ; then
1781  MOUNTDEVICE="$(getbootparam 'partconf' 2>>$DEBUG)"
1782  if [ -n "$MOUNTDEVICE" ]; then
1783    [ -d /mnt/grml ] || mkdir /mnt/grml
1784    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1785     if [[ $RC == 0 ]]; then
1786       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1787       einfo "Copying files from $MOUNTDEVICE over grml system."
1788       for file in `cat /etc/grml/partconf` ; do
1789         [ -d /mnt/grml/$file ] && cp -a /mnt/grml/${file}* ${file} && echo "copied: $file"
1790         [ -f /mnt/grml/$file ] && cp -a /mnt/grml/${file}  ${file} && echo "copied: $file"
1791       done && eend 0
1792     else
1793       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1794     fi # mount $MOUNTDEVICE
1795    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1796  else
1797    einfo "Sorry, no device for bootoption partconf provided. Skipping." ; eend 1
1798  fi # [ -n "$MOUNTDEVICE" ]
1799 fi
1800 }
1801 # }}}
1802
1803 # {{{ /cdrom/.*-options
1804 config_debs(){
1805 if checkbootparam "debs" ; then
1806   DEBS="$(getbootparam 'debs' 2>>$DEBUG)"
1807   einfo "Tring to install debian package(s) ${DEBS}"
1808   dpkg -i /cdrom/debs/$DEBS* ; eend $?
1809 fi
1810 }
1811
1812 config_scripts(){
1813 if checkbootparam "scripts" ; then
1814   SCRIPTS="$(getbootparam 'scripts' 2>>$DEBUG)"
1815   [ -z "$SCRIPTS" ] && SCRIPTS='grml.sh'
1816   einfo "Bootparameter scripts found. Trying to execute ${SCRIPTS}:"
1817   sh -c /cdrom/scripts/$SCRIPTS ; eend $?
1818 fi
1819 }
1820 # }}}
1821
1822 # {{{ distcc
1823 config_distcc(){
1824 if checkbootparam "distcc" ; then
1825  OPTIONS="$(getbootparam distcc 2>>$DEBUG)"
1826  if [ -n "$OPTIONS" ]; then
1827     NET=""
1828     INTERFACE=""
1829     if [ -n "$OPTIONS" ]; then
1830       NET="${OPTIONS%%,*}"
1831       R="${OPTIONS#*,}"
1832       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1833         OPTIONS="$R"
1834         INTERFACE="${OPTIONS%%,*}"
1835         R="${OPTIONS#*,}"
1836       fi
1837     fi
1838  fi
1839  CONFIG=/etc/default/distcc
1840  sed -i "s#^STARTDISTCC=.*#STARTDISTCC=YES#"  $CONFIG
1841  sed -i "s#^ALLOWEDNETS=.*#ALLOWEDNETS=$NET#" $CONFIG
1842
1843  if [ -n "$INTERFACE" ] ; then
1844    IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
1845
1846    counter=10
1847    while [ -z "$IP" ] && [[ "$counter" != 0 ]] ; do
1848      counter=$(( counter-1 ))
1849      ewarn "No ip address for $INTERFACE found. Sleeping for 3 seconds. $counter tries left."
1850      sleep 3
1851      IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
1852    done
1853  fi
1854
1855  if [ -n "$IP" ] ; then
1856    sed -i "s#^LISTENER=.*#LISTENER=$IP#"      $CONFIG
1857
1858    einfo "Bootoption distcc found. Preparing setup for distcc daemon."
1859    eindent
1860     id distccd >/dev/null 2>&1 || \
1861     (
1862       einfo "Creating distcc user" ; \
1863       adduser --quiet --system --ingroup nogroup --home / --no-create-home distccd ; eend $?
1864     )
1865
1866     einfo "Starting distcc for network ${NET}, listening on ${IP}."
1867    /etc/init.d/distcc start 1>/dev/null ; eend $?
1868    eoutdent
1869  else
1870    eerror "No ip address for $INTERFACE found. distcc can not be used without it." ; eend 1
1871  fi
1872 fi
1873
1874 if checkbootparam "gcc"; then
1875  GCC="$(getbootparam gcc 2>>$DEBUG)"
1876  eindent
1877  einfo "Pointing /usr/bin/gcc to /usr/bin/gcc-${GCC}."
1878  eoutdent
1879  rm -f /usr/bin/gcc
1880  ln -s /usr/bin/gcc-${GCC} /usr/bin/gcc ; eend $?
1881 fi
1882
1883 if checkbootparam "gpp"; then
1884  GPP="$(getbootparam gpp 2>>$DEBUG)"
1885  eindent
1886   einfo "Pointing /usr/bin/g++ to /usr/bin/g++-${GPP}."
1887   if [ -x /usr/bin/g++-${GPP} ] ; then
1888      rm -f /usr/bin/g++
1889      ln -s /usr/bin/g++-${GPP} /usr/bin/g++ ; eend $?
1890   fi
1891   einfo "Pointing /usr/bin/cpp to /usr/bin/cpp-${GPP}."
1892   if [ -x /usr/bin/cpp-${GPP} ] ; then
1893      rm -f /usr/bin/cpp
1894      ln -s /usr/bin/cpp-${GPP} /usr/bin/cpp ; eend $?
1895   fi
1896  eoutdent
1897 fi
1898
1899 }
1900 # }}}
1901
1902 # {{{ load modules
1903 # Notice: use it only on live-cd system, if running from harddisk please
1904 # add modules to /etc/modules and activate /etc/init.d/module-init-tools
1905 # in /etc/runlevel.conf
1906 config_modules(){
1907 MODULES_FILE=/etc/grml/modules
1908 if checkbootparam nomodules ; then
1909   ewarn "Skipping loading of modules defined in ${MODULES_FILE} as requested." ; eend 0
1910 elif [ -z "$INSTALLED" ]; then
1911  if [ -r $MODULES_FILE ] ; then
1912   einfo "Loading modules specified in ${MODULES_FILE}:"
1913   eindent
1914   grep '^[^#]' $MODULES_FILE | \
1915   while read module args; do
1916     [ "$module" ] || continue
1917       einfo "${module}"
1918       modprobe $module $args ; eend $?
1919   done
1920   eoutdent
1921  else
1922   ewarn "File $MODULES_FILE does not exist. Skipping loading of specific modules." ; eend 1
1923  fi
1924 fi
1925 }
1926 # }}}
1927
1928 # {{{ 915resolution
1929 config_915resolution(){
1930 if checkbootparam "915resolution" ; then
1931  OPTIONS="$(getbootparam 915resolution 2>>$DEBUG)"
1932   if [ -x /usr/sbin/915resolution ]; then
1933     CMD=915resolution
1934     MODE=""
1935     XRESO=""
1936     YRESO=""
1937     if [ -n "$OPTIONS" ]; then
1938       # Extra options
1939       MODE="${OPTIONS%%,*}"
1940       R="${OPTIONS#*,}"
1941       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1942         OPTIONS="$R"
1943         XRESO="${OPTIONS%%,*}"
1944         R="${OPTIONS#*,}"
1945         if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1946           OPTIONS="$R"
1947           YRESO="${OPTIONS%%,*}"
1948           R="${OPTIONS#*,}"
1949         fi
1950       fi
1951     fi
1952     einfo "Running 915resolution with options ${MODE} ${XRESO} ${YRESO}."
1953     [ -n "$MODE" ] && [ -n "$XRESO"  ] && [ -n "$YRESO" ]  && ( sh -c "$CMD $MODE $XRESO $YRESO" & )
1954     eend 0
1955   fi
1956 fi
1957 }
1958 # }}}
1959
1960 # {{{ SW-RAID
1961 config_swraid(){
1962   if [ -z "$INSTALLED" ] ; then
1963   # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
1964   if checkbootparam 'noraid'   -o checkbootparam 'noswraid' -o \
1965      checkbootparam 'forensic' -o checkbootparam 'raid=noautodetect' ; then
1966      ewarn "Skipping SW-RAID code as requested on boot commandline." ; eend 0
1967   else
1968     if ! [ -x /sbin/mdadm ] ; then
1969        eerror "mdadm not available, can not execute it." ; eend 1
1970     else
1971
1972        # if ! egrep -qv '^(MAILADDR.*|#.*|)$' /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
1973        # find out whether we have a valid configuration file already
1974        if ! grep -q ARRAY /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
1975           einfo "Creating /etc/mdadm/mdadm.conf for use with mdadm."
1976           [ -r /etc/mdadm/mdadm.conf ] && mv /etc/mdadm/mdadm.conf /etc/mdadm/mdadm.conf.old
1977           MDADM_MAILADDR__='root' /usr/share/mdadm/mkconf > /etc/mdadm/mdadm.conf ; eend $?
1978         else
1979           ewarn "/etc/mdadm/mdadm.conf looks like a configured mdadm setup, will not touch it." ; eend 0
1980        fi
1981
1982        if ! checkbootparam 'swraid' ; then
1983           eindent
1984           einfo "Just run 'Start mdadm-raid' to assemble md arrays or boot using 'swraid' as bootoption for autostart."
1985           eoutdent
1986        else
1987           einfo "Bootoption swraid found. Searching for software RAID arrays:"
1988           eindent
1989            IFSOLD=${IFS:-}
1990            IFS='
1991 '
1992            for line in $(mdadm --assemble --scan --auto=yes --symlink=no 2>&1) ; do
1993                case $line in
1994                  *'No arrays found'*)
1995                    ewarn "$line" ; eend 0
1996                    ;;
1997                  *)
1998                    einfo "$line" ; eend 0
1999                    ;;
2000                esac
2001            done
2002            IFS=$IFSOLD
2003          eoutdent
2004
2005          if [ -r /proc/mdstat ] ; then
2006             eindent
2007             MDSTAT=$(grep '^md[0-9]' /proc/mdstat)
2008             if [ -z "$MDSTAT" ] ; then
2009                ewarn "No active arrays found" ; eend 0
2010             else
2011                IFSOLD=${IFS:-}
2012                IFS='
2013 '
2014                for line in $(grep '^md[0-9]' /proc/mdstat) ; do
2015                    einfo "active arrays: $line" ; eend 0
2016                done
2017                IFS=$IFSOLD
2018             fi
2019             eoutdent
2020          fi # /proc/mdstat
2021        fi # bootoption swraid
2022
2023      fi # is /sbin/mdadm executable?
2024   fi # check for bootoptions
2025   fi # run only in live-cd mode
2026 }
2027 # }}}
2028
2029 # {{{ debnet: setup network based on an existing one found on a partition
2030 config_debnet(){
2031 if checkbootparam "debnet" ; then
2032  iszsh && setopt shwordsplit
2033  DEVICES="$(< /proc/partitions tail -n +3 | awk '{print "/dev/"$4}' | tr "\n" " ")"
2034  DEVICES="$DEVICES $(ls /dev/mapper/*)"
2035  FOUND_DEBNET=""
2036
2037  einfo "Bootoption 'debnet' found. Searching for Debian network configuration: "
2038  eindent
2039  if ! mount | grep '/mnt ' 1>/dev/null 2>&1 ; then
2040     for i in $DEVICES; do
2041      if mount -o ro -t auto "$i" /mnt >/dev/null 2>&1; then
2042          einfo "Scanning on $i"
2043        if [ -f /mnt/etc/network/interfaces ]; then
2044          einfo "/etc/network/interfaces found on ${i}" ; eend 0
2045          FOUND_DEBNET="$i"
2046          break
2047        fi
2048        umount /mnt
2049      fi
2050     done
2051
2052    if [ -n "$FOUND_DEBNET" ]; then
2053      einfo "Stopping network."
2054        pump -k 1>/dev/null 2>&1
2055        /etc/init.d/networking stop 1>/dev/null 2>&1 ; eend $?
2056      einfo "Copying Debian network configuration from $FOUND_DEBNET to running system."
2057        rm -rf /etc/network/run
2058        cp -a /mnt/etc/network /etc
2059        rm -rf /etc/network/run
2060        mkdir /etc/network/run
2061        umount /mnt ; eend $?
2062      einfo "Starting network."
2063        /etc/init.d/networking start ; eend $?
2064    else
2065      eerror "/etc/network/interfaces not found." ; eend 1
2066    fi
2067    eoutdent
2068  else
2069   eerror "Error: /mnt already mounted." ; eend 1
2070  fi
2071 fi
2072 }
2073 # }}}
2074
2075 # {{{ disable console blanking
2076 config_blanking(){
2077 if checkbootparam "noblank" ; then
2078   einfo "Bootoption noblank found. Disabling monitor blanking."
2079   setterm -blank 0 ; eend $?
2080 fi
2081 }
2082 # }}}
2083
2084 # {{{ grml2hd: automatic installation
2085 config_grml2hd(){
2086
2087 if checkbootparam "user" ; then
2088   NEWUSER=''
2089   NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
2090   sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2091 fi
2092
2093 if checkbootparam "filesystem" ; then
2094   FILESYSTEM=''
2095   FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
2096   sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2097 fi
2098
2099 if checkbootparam "partition" ; then
2100   PARTITION=''
2101   PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
2102   # notice: the following checks whether the given partition is available, if not the skip
2103   # execution of grml2hd as it might result in data loss...
2104   if [ -r $PARTITION ] ; then
2105     sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2106   else
2107     ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
2108   fi
2109 fi
2110
2111 if checkbootparam "mbr" ; then
2112   BOOT_PARTITION=''
2113   BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
2114   sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2115 fi
2116
2117 if stringinstring "BOOT_IMAGE=grml2hd " "$CMDLINE" ; then
2118   cat>|/usr/bin/grml2hd_noninteractive<<EOF
2119 #!/bin/sh
2120 GRML2HD_NONINTERACTIVE='yes' grml2hd
2121 EOF
2122   chmod 755 /usr/bin/grml2hd_noninteractive
2123   einfo "Bootparameter grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
2124   if [ -z "$GRML2HD_FAIL" ] ; then
2125     screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
2126   else
2127     ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
2128   fi
2129 fi
2130 }
2131 # }}}
2132
2133 ### {{{ backwards compatible stuff
2134 config_environment(){
2135   ewarn "config_environment is deprecated. Please set CONFIG_ENVIRONMENT in /etc/grml/autoconfig to 'no'." ; eend 0
2136 }
2137 config_keyboard(){
2138   ewarn "config_keyboard is deprecated. Please set CONFIG_KEYBOARD in /etc/grml/autoconfig to 'no'." ; eend 0
2139 }
2140 # }}}
2141
2142 ## END OF FILE #################################################################
2143 # vim:foldmethod=marker